#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <icv150.h>

extern int errno;

void main (unsigned int argc, char **argv)
{
	int	FD, n1=0, n2, i, j;
	u8	cmd;
	u16	arg[MAX_CHANNELS];

        if (argc > 1) {
                FD = open (argv[1], O_RDWR, 0x666);
		printf("\n\nopened %s File Descriptor = %d", argv[1], FD);
        }
        else {
		FD = open ("/dev/icv150_1", O_RDWR, 0x666);
		printf("\n\nopened /dev/icv150_1 File Descriptor = %d", FD);
        }

 

	if (FD == -1)
	{
		printf("\n\nError, unable to open the ICV150 board (errno=%d)\n",errno);
		exit (0);
	}

	while (n1 != 20)
	{
		printf("\n\n\n*** MENU 1 ***\n1. RD_CHANNEL\n2. RD_ALL_CHANNELS\n3. RD_GAIN\n4. RD_ALL_GAINS\n5. SET_NUMBER\n6. SET_GAIN\n7. SET_ALL_GAINS\n8. START\n9. EXT_TRIG\n10. STOP\n11. STORE\n12. RECALL\n13. DEBUG\n20. Quit\n\nYour choise : ");
		scanf("%d",&n1);
		switch (n1)
		{
		case 1:
			cmd = RD_CHANNEL;

			printf("\n\n\tEnter channel number (0-%d) : ", MAX_CHANNELS);
			scanf("%d", &i);
			arg[0] = (u8) (i & 0x00FF);

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : RD_CHANNEL | channel %d | value %#04X", i&0x00FF, arg[0]);
			else
				printf("\n\n\t\tError : Check channel number and board status\n\t\t(must be scanning - errno = %d)",errno);
 			break;

		case 2:
			cmd = RD_ALL_CHANNELS;

			if ( !ioctl(FD, cmd, arg) )
			{
				printf("\n\n\t\tDone : RD_ALL_CHANNEL"); 
				for (i=0; i<DEF_CHANNELS; i++)
					printf("\n\t\tchannel %d | value %#04X", i, arg[i]);
			}
			else
				printf("\n\n\t\tError : Check board status\n\t\t(must be scanning - errno = %d)", errno);
 			break;

		case 3:
			cmd = RD_GAIN;

			printf("\n\n\tEnter channel number (0-%d) : ", MAX_CHANNELS);
			scanf("%d", &i);
			arg[0] = (u8) (i & 0x00FF);

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : RD_GAIN | channel %d | gain value %#01X", i&0x00FF, arg[0]);
			else
				printf("\n\n\t\tError : Check channel number and board status\n\t\t(must be stopped - errno = %d)", errno);
 			break;

		case 4:
			cmd = RD_ALL_GAINS;

			if ( !ioctl(FD, cmd, arg) )
			{
				printf("\n\n\t\tDone : RD_ALL_GAINS"); 
				for (i=0; i<DEF_CHANNELS; i++)
					printf("\n\t\tchannel %d | gain value %#01X", i, arg[i]);
			}
			else
				printf("\n\n\t\tError : Check board status\n\t\t(must be stopped - errno = %d)", errno);
 			break;

		case 5:
			cmd = SET_NUMBER;

			printf("\n\n\tEnter number of channels (0-%d) : ", MAX_CHANNELS);
			scanf("%d", &i);
			arg[0] = (u8) (i & 0x00FF);

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : SET_NUMBER | new number is %d", arg[0]);
			else
				printf("\n\n\t\tError : Check board status\n\t\t(must be stopped - errno = %d)", errno);
 			break;

		case 6:
			cmd = SET_GAIN;

			printf("\n\n\tEnter channel number (0-%d) : ", MAX_CHANNELS);
			scanf("%d", &i);
			arg[0] = (u8) (i & 0x00FF);
			printf("\n\tEnter gain (0-%d) : ", MAX_GAIN);
			scanf("%d", &i);
			arg[1] = (u8) (i & 0x00FF);

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : SET_GAIN | channel %d | gain value %#01X", arg[0], arg[1]);
			else
				printf("\n\n\t\tError : Check channel number and board status\n\t\t(must be stopped - errno = %d)", errno);
 			break;

		case 7:
			cmd = SET_ALL_GAINS;

			printf("\n");
			for(j=0; j<DEF_CHANNELS; j++)
			{
				printf("\n\tEnter gain (0-%d) : ", MAX_GAIN);
				scanf("%d", &i);
				arg[j] = (u8) (i & 0x00FF);
			}

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : SET_ALL_GAINS");
			else
				printf("\n\n\t\tError : Check board status\n\t\t(must be stopped - errno = %d)", errno);
 			break;

		case 8:
			cmd = START;

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : START");
			else
				printf("\n\n\t\tError : errno = %d", errno);
 			break;

		case 9:
			cmd = EXT_TRIG;

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : EXT_TRIG");
			else
				printf("\n\n\t\tError : errno = %d", errno);
 			break;

		case 10:
			cmd = STOP;

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : STOP");
			else
				printf("\n\n\t\tError : errno = %d", errno);
 			break;

		case 11:
			cmd = STORE;

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : STORE");
			else
				printf("\n\n\t\tError : errno = %d", errno);
 			break;

		case 12:
			cmd = RECALL;

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : RECALL");
			else
				printf("\n\n\t\tError : errno = %d", errno);
 			break;

		case 13:
			cmd = DEBUG;

			printf("\n\n\tEnter DEBUG level (0-4) : ");
			scanf("%d", &i);
			arg[0] = (u8) (i & 0x00FF);

			if ( !ioctl(FD, cmd, arg) )
				printf("\n\n\t\tDone : DEBUG | level %d", arg[0]);
			else
				printf("\n\n\t\tError : errno = %d", errno);
 			break;

		case 20:
			break;

		default:
			printf("Bad command\n");
			break;
		}
	}

	close (FD);
}	
